package asd.td2;

import java.io.*;
import java.util.*;

/**
 * Une classe pour les suites d'entiers, pour l'exercice 2 de la feuille 2.
 * Une telle suite est la mme que celle des exercices 9  12 de la feuille
 * 1 mais pour des raisons de commodits, on rpte cette classe ici.
 *  2002 Marc Gatano
 */
public class Suite {

    // la suite est implmente  l'aide d'un tableau et d'un indice
    // (le curseur)

    private int[] t;
    private int i;

    /**
     * Construit une suite contenant exactement les lments de table.
     * Complexit : O(1).
     */
    public Suite(int[] table) {
	t = table;
	i = 0;
    }

    /**
     * Construit la suite vide.
     * Complexit : O(1).
     */
    public Suite() {
	t = new int[0];
	i = 0;
    }

    /**
     * Place le curseur de la suite au dbut (c'est  dire sur le premier
     * lment ou en fin de suite si la suite est vide).
     * Complexit : O(1).
     */
    public void debut() {
	i = 0;
    }

    /**
     * Si le curseur n'est pas en fin de suite, retourne l'entier point
     * par le curseur.
     * Prcondition : fin() = false.
     * Complexit : O(1).
     */
    public int valeurCourante() {
	return t[i];
    }

    /**
     * Si le curseur n'est pas en fin de suite, dplace le curseur sur
     * l'lment suivant, ou en fin de suite si l'lment courant tait
     * le dernier.
     * Prcondition : fin() = false.
     * Complexit : O(1).
     */
    public void suivant() {
	i++;
    }

    /**
     * Indique si on est en fin de suite, autrement dit si le curseur pointe
     * au-del du dernier lment.
     * Complexit : O(1).
     */
    public boolean fin() {
	return i == t.length;
    }

    /**
     * Retourne la longueur de la suite (le nombre d'lments).
     * Complexit : O(1).
     */
    public int longueur() {
	return t.length;
    }
    
    // pour afficher l'lment courant
    //
    private String toString(int j) {
	if ( j == i ) {
	    return "|" + String.valueOf(t[j]) + "|";
	}
	else {
	    return String.valueOf(t[j]);
	}
    }

    /**
     * La reprsentation externe d'une suite.
     * Complexit : O(n) o n est la longueur de la suite.
     */
    public String toString() {
	if ( t.length == 0 ) {
	    return "<>";
	}
	String s = "<" + toString(0);
	for ( int j = 1; j < t.length; j++ ) {
	    s = s + ", " + toString(j);
	}
	s = s + ">";
	return s;
    }
}
